/*  File:     parser.java 
    Project:  OOPracktikum 2001
	            Connect-Game Info Client
	            Patrick Scheibe, Markus Kreuz, Georg Martius
    Package:  parser
    Autor:    Georg Martius
    Descript: Parser von fr ein String der folgenden Form
		<Knoten> 		::= <Konstruktor><Knoten> | <Liste> | <Tupel> | <Record> | <Zahl> | <String>
		<Konstruktor> 	::= Bezeichner
		<Liste>			::= [<Knoten>,<Knoten>,...]
		<Tupel>			::= (<Knoten>,<Knoten>,...)
		<Record> 		::= {<Bindung>,<Bindung>,...}
		<Bindung>		::= Bezeichner=<Knoten>
		<String>		::= "Zeichenfolge"
		<Zahl>			::= [1-9][0-9]* # mal als reg-exp :-)
		
		und baut einen Syntaxbaum auf.
		
	create:
	date
	Fri Jun  1 16:08:31 MET DST 2001
		
    last mod: 
	date 
	Fri Jun  1 16:08:17 MET DST 2001
*/

// package parser;

import knoten;

class parser{
	///////////////// MEMBER /////////////////////////////
	knoten syntaxBaum;
	boolean istaufgebaut;

	///////////////// DEKLARATIONEN /////////////////////////////
  //########gibt Baum auf Konsole aus
  //  public void printBaum();
 	//#######baut aus string einen Baum auf und speichert Ihn im Syntaxbaum
  //	public boolean baueBaum(String string);
  //#######gibt Baum zurck
  //  public knoten getSyntaxBaum(){
  //  public boolean istAufgebaut(){

	
	///////////////// DEFINITIONEN /////////////////////////////

	//-----------------------------------------------------------------------
	public parser(){
        String rest;
	    syntaxBaum = new knoten();
		istaufgebaut = false;

		baueBaum("test([1,2,],\"String\", record{var1=\"Werte\", var2=345345})");
        printBaum();
	}

	// baut aus string einen Baum auf und speichert Ihn im Syntaxbaum
	// wenn schon aufgebaut, dann wird der alte Baum gelscht!!!
	//-----------------------------------------------------------------------
	public boolean baueBaum(String string){
    String rest = new String();
		try {
			rest= syntaxBaum.parse(string);
		}catch(parseException e){
			e.printStackTrace(System.out);
		}
    
      if(rest==null || (rest=rest.trim())==null || rest.length()!=0){
  	     	System.out.println("Parsen hat nicht geklappt bzw. es steht zuviel da! Rest: "+ rest);
		    return false;
      }
      
  	  istaufgebaut = true;
    
	  return true;
	}
  
  // gibt Baum auf Konsole aus
  //-----------------------------------------------------------------------
  public void printBaum(){
    if(istaufgebaut) syntaxBaum.printBaum(0,false);
  }
	
  // gibt Baum zurck
  // return: null wenn nicht istaufgebaut
  //-----------------------------------------------------------------------
  public knoten getSyntaxBaum(){
    if(istaufgebaut) return syntaxBaum;
    else return null;
  }
  
  // return: istaufgebaut
  //-----------------------------------------------------------------------
  public boolean istAufgebaut(){
    return istaufgebaut;
  }
  
  
  //-----------------------------------------------------------------------	
  public static void main(String[] argv){
	  parser myself=new parser();
  }
}




